#include <stdio.h>
#include <stdlib.h>
#include <glob.h>
#include <errno.h>
#include <limits.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>

#include "util.h"

#define DEFAULT_MIME_TYPE "image/gif"
#define DEFAULT_MIME_INFO "i"
static int zoom=2;

#define MAX_ZOOM 65536

static char buf[LINE_MAX];
static char *section,*nametag;
static unsigned numareas;

static void outline(const char *s,int par0,int par1,int par2,int par3)
{
	par0/=zoom; par1/=zoom; par2/=zoom;
	if (par3) if (!(par3/=zoom)) par3=1;
	printf(" <AREA HREF=\"ircond.cgi?%s+%s-%s\" ALT=\"%s-%s\" SHAPE=\"%s\" COORDS=\"%d,%d,%d",
			nametag,section,s,section,s,(!par3?"CIRCLE":"RECT"),par0,par1,par2);
	if (par3) printf(",%d",par3);
	else {
		par0-=par2; par1-=par2;
		par3=par1+(par2*=2); par2+=par0;
		}
	printf("\">\n <PARAM NAME=\"Area%u\" VALUE=\"%u %u %u %u %s-%s\">\n",numareas++,par0,par1,par2,par3,section,s);
}

int main(int argc,char **argv)
{
const char *mimetype=DEFAULT_MIME_TYPE,*mimeinfo=DEFAULT_MIME_INFO;
glob_t globbuf;
char **curfn,*fn,*s;
size_t siz;
long pars[4],lastcirc;
int parn,cons;
unsigned sizX,sizY;
	pname=argv[0];
	if ((s=getenv("QUERY_STRING"))) while (*s) {
char c,*val,*ss,*d;
		for (d=ss=s;*s&&*s!='&';s++) {
			if (*s=='+') *d++=' ';
			else if (*s=='%'&&isxdigit(s[1])&&isxdigit(s[2])) {
char xbuf[3]={s[1],s[2],'\0'};
				*d++=strtol(xbuf,NULL,16);
				}
			else *d++=*s;
			}
		c=*s; *d='\0';
		if ((val=strchr(ss,'='))) {
			*val++='\0';
			     if (!strcmp(ss,"MIME" )) mimetype=val;
			else if (!strcmp(ss,"MIMEI")) mimeinfo=val;
			else if (!strcmp(ss,"ZOOM" )) zoom=atoi(val);
			}
		if (c) s++;
		}
	if (zoom<1) zoom=1;
	else if (zoom>MAX_ZOOM) zoom=MAX_ZOOM;
	if (glob("?*.def",0,NULL,&globbuf)) {
		perror("genpage.cgi: glob() fail");
		exit(EXIT_FAILURE);
		}
	printf("Content-type: text/html\n\n");
	for (curfn=globbuf.gl_pathv;(fn=*curfn);curfn++) {
FILE *f;
		if (!(f=fopen(fn,"rt"))) errout("fopen(\"%s\") - %s",fn,strerror(errno));
		do {
			if (!fgets(buf,sizeof(buf),f)) errout("Reading size-info of \"%s\"",fn);
			procbuf(buf);
			} while (!*buf);
		if (sscanf(buf,"%ux%u%n",&sizX,&sizY,&cons)!=2||buf[cons]) errout("Parsing size-info of \"%s\"",fn);
		if ((sizX/=zoom)<1) sizX=1;
		if ((sizY/=zoom)<1) sizY=1;
		chk(nametag=malloc((siz=strlen(fn)-4)+1));
		memcpy(nametag,fn,siz);
		nametag[siz]='\0';
		sprintf(buf,"imgconv.cgi?%s.png&%u&%u&%s&%s",nametag,sizX,sizY,mimetype,mimeinfo);
		printf("\
<A NAME=\"%s\">\n\
<APPLET CODE=\"Control.class\" ALIGN=\"TOP\" WIDTH=%u HEIGHT=%u><PARAM NAME=\"ImageName\" VALUE=\"%s\">\n\
<IMG SRC=\"%s\" ALT=\"%s\" USEMAP=\"#%s\" BORDER=0 ALIGN=\"TOP\" WIDTH=%u HEIGHT=%u>\n<MAP NAME=\"%s\">\n\
",nametag,sizX,sizY,buf,buf,nametag,nametag,sizX,sizY,nametag);
		lastcirc=LONG_MAX;
		section=NULL;
		numareas=0;
		while (fgets(buf,sizeof(buf),f)) {
			procbuf(buf);
			if  (!*buf)
				continue;
	
			if (*buf!=' '&&*buf!='#') { /* new section */
				free(section); section=strdup(buf);
				continue;
				}
			/* area */
			if (!section) errout("Section not defined for area \"%s\" in file \"%s\"",buf,fn);
			s=buf+1;
			if (*buf=='#') { /* table mark */
unsigned cols,rows,firstTX,firstTY,firstBX,firstBY,lastTX,lastTY,radius;
unsigned row,col,curX,curY;
enum { TP_UNDEF, TP_RECT, TP_CIRC } tp=TP_UNDEF;
				if (sscanf(s,"%u,%u,%u,%u,%u,%u,%u,%u%n",&cols,&rows,&firstTX,&firstTY,&firstBX,&firstBY,&lastTX,&lastTY,&cons)==8&&!s[cons]) tp=TP_RECT;
				else if (sscanf(s,"%u,%u,%u,%u,%u,%u,%u%n",&cols,&rows,&firstTX,&firstTY,&lastTX,&lastTY,&radius,&cons)==7&&!s[cons]) tp=TP_CIRC;
				if (tp==TP_UNDEF||rows<1||cols<1) errout("Inappropriate parameters for area \"%s\" in file \"%s\"",buf,fn);
				rows--; cols--;
				for (row=0;row<=rows;row++)
				for (col=0;col<=cols;col++) {
					do {
						if (!fgets(buf,sizeof(buf),f)) errout("Read error during table processing in file \"%s\"",fn);
						procbuf(buf);
						} while (!*buf);
					if (*buf!=' ') errout("Area item expected for area \"%s\" in file \"%s\"",buf,fn);
					curY=(lastTY-firstTY)*row/(rows?rows:1);
					curX=(lastTX-firstTX)*col/(cols?cols:1);
					if (!strcmp(buf," -")) continue;
					if (tp==TP_RECT) outline(buf+1,firstTX+curX,firstTY+curY,firstBX+curX,firstBY+curY);
					else outline(buf+1,firstTX+curX,firstTY+curY,radius,0);
					}
				continue;
				}
			parn=0;
			do {
				if (parn>=4) errout("Too many parameters for area \"%s\" in file \"%s\"",buf,fn);
				pars[parn++]=strtol(s,&s,0);
				if (*s!=','&&*s!='=') errout("Garbage following parameters for area \"%s\" in file \"%s\"",buf,fn);
				} while (*s++==',');
			if (parn<2) errout("Too few parameters for area \"%s\" in file \"%s\"",buf,fn);
			if (parn==2)
				if (lastcirc==LONG_MAX) errout("Default circle value not defined for ommited one for area \"%s\" in file \"%s\"",buf,fn);
				else pars[parn++]=lastcirc;
				outline(s,pars[0],pars[1],pars[2],parn==4?pars[3]:0);
				if (parn==3) lastcirc=pars[2];
			}
		printf("</MAP>\n<PARAM NAME=\"NumAreas\" VALUE=%u>\n</APPLET>\n",numareas);
		free(section); free(nametag);
		fclose(f);
		}
	globfree(&globbuf);
	printf("<HR>\n");
	if (zoom<=3) {
static const char ln[]="<IMG SRC=\"/icons/newicons/%s.gif\" ALT=\"%s\" WIDTH=32 HEIGHT=32 BORDER=0>";
static const char *a[][2]={/*0*/{"office/filefind","Zoom"},/*1*/{"computer/keys","x1"},/*2*/{"computer/keybd","x1/2"},/*3*/{"computer/keyboard","x1/3"},
/*4*/{"signs/redx","No way"},/*5*/{"arrow/granite_left","Left"},/*6*/{"arrow/granite_right","Right"},/*7*/{"arrow/granite_top","Current"}};
int m[5]={0,0,0,0,0},i,j,f;
		printf("<TABLE ALIGN=CENTER>\n");
		m[zoom-1]=5; m[zoom]=7; m[zoom+1]=6;
		if (m[0]) m[0]=4;
		if (m[4]) m[4]=4;
		for (j=0;j<2;j++) {
			printf("<TR>\n");
			for (i=0;i<5;i++) {
				printf("<TD>");
				if (!j||m[i]) {
					if ((f=(i>=1&&i<=3&&i!=zoom&&(!j||i==zoom-1||i==zoom+1)))) printf("<A HREF=\"?ZOOM=%u&MIME=%s\">",i,mimetype);
					printf(ln,a[j?m[i]:i&3][0],a[j?m[i]:i&3][1]);
					if (f) printf("</A>");
					}
				printf("</TD>\n");
				}
			printf("</TR>\n");
			}
		printf("<CAPTION>Current image resolution:</CAPTION></TABLE>\n");
		}
	else printf("<DIV ALIGN=CENTER>As you already specified a custom resolution, you probably know how to change it manually!</DIV>\n");
		{
static const char *a[][3]={
{"Portable Network Graphics Interlaced (PNG:","image/png","i"},
{"Portable Network Graphics (PNG:","image/png",""},
{"Compuserve Graphics Interchange Format Interlaced (GIF:","image/gif","i"},
{"Compuserve Graphics Interchange Format (GIF:","image/gif",""},
{"JFIF/JPEG format Progressive (JPEG:","image/jpeg","p"},
{"JFIF/JPEG format (JPEG:","image/jpeg",""}};
int i,f;
		printf("<TABLE ALIGN=CENTER BORDER=1 CELLPADDING=1>\n");
		for (i=0;i<sizeof(a)/sizeof(*a);i++) {
			printf("<TR><TD>");
			if ((f=(!strcmp(mimetype,a[i][1])&&!strcmp(mimeinfo,a[i][2])))) printf("<STRONG>");
			else printf("<A HREF=\"?ZOOM=%u&MIME=%s&MIMEI=%s\">",zoom,a[i][1],a[i][2]);
			printf("%s%s)",a[i][0],a[i][1]);
			if (f) printf("</STRONG>");
			else printf("</A>");
			printf("</TD></TR>\n");
			}
		printf("<CAPTION>Current image format:</CAPTION></TABLE>\n");
		}
	return(EXIT_SUCCESS);
}
