#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <limits.h>

#include "util.h"
#include "ircode-db.h"

static char linebuf[LINE_MAX];

#define CODE_FILENAME "/etc/ircode-db.txt"

struct dbrec {
	char *name,*bits;
	struct dbrec *next;
	} *irdb;

void irdb_load(const char *fn)
{
FILE *fi;
struct dbrec **recp=&irdb,*rec;
char *s,*t;
unsigned line=0;
	if (!fn) fn=CODE_FILENAME;
	if (!(fi=fopen(fn,"r"))) {
		fprintf(stderr,"Unable to open `%s' database!\n",fn);
		exit(EXIT_FAILURE);
		}
	while (fgets(linebuf,sizeof(linebuf),fi)) {
		procbuf(linebuf);
		line++;
		if (!*linebuf) continue;
		rec=NULL;
		for (s=linebuf;*s;s++)
			if (*s=='=') {
				*s='\0';
				t=s+1;
				while (--s>linebuf)
					if (*s==' ') *s='\0';
					else break;
				chk(rec=malloc(sizeof(*rec)));
				*recp=rec;
				recp=&rec->next;
				chk(rec->name=strdup(linebuf));
				chk(rec->bits=strdup(t));
				break;
				}
		if (!rec) {
			fprintf(stderr,"Corrupted database `%s' at line %u\n",fn,line);
			exit(EXIT_FAILURE);
			}
		}
	*recp=NULL;
	fclose(fi);
}

const char *irdb_getname(const char *vendor,const char *bits)
{
struct dbrec *rec;
size_t len=strlen(vendor);
	for (rec=irdb;rec;rec=rec->next)
		if (!strncmp(rec->name,vendor,len)&&rec->name[len]=='-'&&!strcmp(bits,rec->bits))
			break;
	return (rec?rec->name:NULL);
}

const char *irdb_getbits(const char *name)
{
struct dbrec *rec;
	for (rec=irdb;rec;rec=rec->next)
		if (!strcmp(rec->name,name))
			return rec->bits;
	return NULL;
}

void irdb_dump(void)
{
struct dbrec *rec;
	for (rec=irdb;rec;rec=rec->next)
		puts(rec->name);
}
