#ifndef _UTIL_H
#define _UTIL_H
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

static const char *pname;

static void errout(const char *fmt,...)
{
va_list ap;
	fprintf(stderr,"%s: ",pname);
	va_start(ap,fmt);
	vfprintf(stderr,fmt,ap);
	va_end(ap);
	fprintf(stderr,"!\n");
	exit(EXIT_FAILURE);
}

static void chk(void *ptr)
{
	if (!ptr) errout("Virtual memory exhausted");
}

static void procbuf(char *buf)
{
char *s;
	if ((s=strchr(buf,'\n'))) *s='\0';
	if ((s=strchr(buf,'\r'))) *s='\0';
	for (s=buf;*s;s++)
		if (*s==';') { *s='\0'; break; }
	s=buf+strlen(buf);
	while (--s>buf)
		if (*s==' ') *s='\0';
		else break;
}

#endif
